from twisted.web.microdom import Document, Element, Text

class Bookmark(Element):
    def __init__(self, title, link):
        Element.__init__(self, 'dt')
        anchor = Element('a', dict(href=link))
        anchor.appendChild(Text(title))
        self.appendChild(anchor)
        # would you believe me if i told you that firefox can't import
        # the bookmarks properly if this newline is missing?  this is
        # because the HTML generated by firefox doesn't have closing tags
        self.appendChild(Text('\n'))

class Folder(Element):
    def __init__(self, name, description, children=None):
        Element.__init__(self, 'dl')
        self.appendChild(Text('\n'))
        self.appendChild(Element('dt'))
        ftitle = Element('h3')
        ftitle.appendChild(Text(name))
        self.appendChild(ftitle)
        desc = Element('dd')
        # the closing </dd> will appear as part of the description unless
        # we add a trailing newline.  wow.
        desc.appendChild(Text(description + '\n'))
        self.appendChild(Text('\n'))
        self.appendChild(desc)
        if children is not None:
            map(self.appendFolderChild, children)
        self.name = name

    def appendFolderChild(self, child):
        self.appendChild(child)

class BookmarkFile(Document):
    doctype = 'NETSCAPE-Bookmark-file-1'

if __name__ == '__main__':
    folder = Folder('Folder One', 'this is folder 1',
                (Bookmark('Folder One, Child One', 'http://f1.c1'),
                 Bookmark('Folder One, Child Two', 'http://f1.c2'),
                 Folder('Subfolder One', 'this is subfolder 1',
                    (Bookmark('Subfolder One, Child One', 'http://sf1.c1'),
                     Bookmark('Subfolder One, Child Two', 'http://sf1.c1'))),
                 Folder('SubFolder Two', 'this is subfolder 2',
                     (Folder('SubSubFolder One', 'this is subsubfolder 1'),
                      Folder('SubSubFolder Two', 'this is subsubfolder 2',
                          (Folder('SubSubSubFolder One', 'this is subsubsubfolder 1',
                              (Bookmark('SubSubSubFolder One, Child One', 'http://sssf1.c1'),)),))))))

    print BookmarkFile(folder).toxml()
